//+------------------------------------------------------------------+
//|                                          MDA7- Moving & MACD.mq4 |
//|                                                             MDA7 |
//|                                              FX.MDA7@YAHOO.CO.UK |
//+------------------------------------------------------------------+
#property copyright "MDA7"
#property link      "FX.MDA7@YAHOO.CO.UK"

double SMA50  ;
double SMA100 ;
double MACD   ;

bool BuyMode  ;
bool SellMode ;

double slB    ;
double slS    ;

extern double Price_Distance = 10; //dar 4raghamiha 10 va dar 5 raghamiha 100 vared konid
extern double LotSize = 0.2 ;
int ticket;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   SMA50  = iMA(Symbol(), 0 , 50  , 0 , 0 , 0 , 0);
   SMA100 = iMA(Symbol(), 0 , 100 , 0 , 0 , 0 , 0);
   
   MACD   = iMACD(Symbol(),0, 12 , 26 , 9 , 0 , 0 ,0);
    
// BUY AND SELL MODES------------------------------------------------+
  
   BuyMode  = ((MACD > 0) && (Bid > SMA50 +Price_Distance * Point) && (Bid > SMA100 + Price_Distance * Point));
   SellMode = ((MACD < 0) && (Bid < SMA50 -Price_Distance * Point) && (Bid < SMA100 - Price_Distance * Point));
   
// StopLoss & TakeProfit---------------------------------------------+

   slB = iLow (Symbol(), 0 , iLowest (Symbol(),0,MODE_LOW , 5 , 0) );
   slS = iHigh(Symbol(), 0 , iHighest(Symbol(),0,MODE_HIGH, 5 , 0) );
   
   
//Orders Counting & Close Orders------------------------------------+

      int orderscnt  = 0;
      
      for(int i=0; i < OrdersTotal(); i++)
         {
         //-Shomareshe Position haye Baz
           OrderSelect(i,SELECT_BY_POS,MODE_TRADES);  
           if((OrderSymbol() == Symbol()) && ((OrderType() == OP_SELL) || (OrderType() == OP_BUY)))
            {
             orderscnt++;
            }
              
         //-Bastane Positione Buy Agar Sharte Sell Bargarar Beshe
            if((OrderSymbol() == Symbol()) && (OrderType() == OP_BUY) && (SellMode))
            {
               OrderClose (OrderTicket(), OrderLots(), Bid, 2, Black);
            }
            
         //-Bastane Positione Sell Agar Sharte Buy Bargarar Beshe
            if((OrderSymbol() == Symbol()) && (OrderType() == OP_SELL) && (BuyMode))
            {
               OrderClose (OrderTicket(), OrderLots(), Ask, 2, Black);
            }
         //-Bastane Nimeye 2vome Positione Buy
            if((OrderSymbol() == Symbol()) && (OrderType() == OP_BUY) && (OrderLots() == LotSize / 2))
            {
               if(Bid < SMA50 -Price_Distance * Point)
               {
                  OrderClose (OrderTicket(), OrderLots(), Bid, 2, Black);
               }
            }
            
         //-Bastane Nimeye 2vome Positione Sell
            if((OrderSymbol() == Symbol()) && (OrderType() == OP_SELL) && (OrderLots() == LotSize /2))
            {
               if(Bid > SMA50 +Price_Distance * Point)
               {
                  OrderClose (OrderTicket(), OrderLots(), Ask, 2, Black);
               }
            }
            
         //-Ja be ja kardane S/L va Bastane Nesfe Sell
            if((OrderSymbol() == Symbol()) && (OrderType() == OP_SELL) && (OrderLots() == LotSize))
            {
               if(OrderOpenPrice() - Ask >= (slS - OrderOpenPrice()) * 2)
               {
                  OrderModify(OrderTicket(), Bid, OrderOpenPrice(), 0, 0, Violet);
                  OrderClose (OrderTicket(), OrderLots() / 2, Ask, 2, Black);
               }
            }
            
         //-Ja be ja kardane S/L va Bastane Nesfe Buy
            if((OrderSymbol() == Symbol()) && (OrderType() == OP_BUY) && (OrderLots() == LotSize))
            {
               if(Bid - OrderOpenPrice() >= (OrderOpenPrice() - slB) * 2)
               {
                  OrderModify(OrderTicket(), Ask, OrderOpenPrice(), 0, 0, Lime);
                  OrderClose (OrderTicket(), OrderLots() / 2, Bid, 2, Black);
               }
            }
         }
         
// Buy AND Sell Orders ----------------------------------------------+

   if((BuyMode) && (orderscnt < 1))
   {
      ticket = OrderSend(Symbol(),OP_BUY,LotSize,Ask, 2 ,slB, 0 ,"Moving & MACD", 123456789 , 0 , Blue);
   }
   
   if((SellMode) && (orderscnt < 1))
   {
      ticket = OrderSend(Symbol(),OP_SELL,LotSize,Bid, 2 ,slS, 0 ,"Moving & MACD", 123456789 , 0 , Red);
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+